#include <fstream>
#include <string>
#include <stdint.h>

using namespace std;

bool palindrome(string &a, int start, int end)
{
	if (start >= end)
	{
		return true;
	}
	if (a[start] != a[end])
	{
		return false;
	}
	return palindrome(a, start + 1, end - 1);
}

string FindLongest(string &a)
{
	int max = INT32_MIN;
	string result;
	for (int i = 0; i < a.length() - 1; i++)
	{
		for (int j = i + 1; j < a.length(); j++)
		{
			if (palindrome(a, i, j))
			{
				if (j - i + 1 > max)
				{
					max = j - i + 1;
					result = a.substr(i, j - i + 1);
				}
			}
		}
	}
	return result;
}

int main()
{
	ifstream input("bai5a.inp");
	ofstream output("bai5a.out");

	string a;
	getline(input, a);
	output << FindLongest(a);

	input.close();
	output.close();
	return 0;
}